## pyhst2 2020c

=== requirements.txt ===
glymur
mpi4py
h5py
cython
fabio

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/pyhst2.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/pyhst2.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/pyhst2"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/pyhst2"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== PyHST/Cspace/pdwt/Makefile ===
NVCC=nvcc
CFLAGS="-arch=sm_30"
LDFLAGS=-lcublas

PDWTCORE=src/wt.cu src/common.cu src/utils.cu src/separable.cu src/nonseparable.cu src/haar.cu src/filters.cpp
PDWTOBJ=build/wt.o build/common.o build/utils.o build/separable.o build/nonseparable.o build/haar.o build/filters.o

#
# Using constant memory accross several files requires to use separate compilation (relocatable device code),
# Otherwise a new constant memory buffer is created for each file (even if the symbol is defined in a common file),
# since __constant__ variables have a file scope linkage. This was fine until the introduction of Wavelets::set_filters().
# As constant memory is managed through the use of "symbols" rather than buffers, another strategy would be to
# get the pointer address with cudaGetSymbolAddress(), which is not recommended.
#
# Separate compilation might be the way to go for better modularity, easier refactoring and compilation speed.
# However, cython does not offer flexibility to make two linkage steps (one "nvcc --dlink" to link the cuda ".o" together,
# the other to link the pyx ".o" with the linked cuda ".o").
#
# If you still want to use separate compilation :
#   - replace "-c $^" with "-dc $^" in the Makefile targets rules
#   - uncomment the definition of SEPARATE_COMPILATION in filters.h
#
demo: $(PDWTCORE) src/demo.cpp src/io.cpp
	mkdir -p build
	$(NVCC) -g $(CFLAGS) -odir build -c $^
	$(NVCC) $(CFLAGS) -o demo $(PDWTOBJ) build/demo.o build/io.o $(LDFLAGS)


libpdwt.so: $(PDWTCORE)
	mkdir -p build
	$(NVCC) $(CFLAGS) --ptxas-options=-v --compiler-options '-fPIC' -odir build -c $^
	$(NVCC) $(CFLAGS)  -o $@ --shared $(PDWTOBJ) $(LDFLAGS)


# Double precision library
libpdwtd.so: $(PDWTCORE)
	mkdir -p build
	$(NVCC) --ptxas-options=-v --compiler-options '-fPIC' -DDOUBLEPRECISION -odir build -c $^
	$(NVCC) $(CFLAGS)  -o $@ --shared $(PDWTOBJ) $(LDFLAGS)



clean:
	rm -rf build demo libpdwt*.so

=== debian/changelog ===
pyhst2 (2020c-7) unstable; urgency=medium

  * Team upload.

  [ Didier Raboud ]
  * Add patch to set Debian-specific PEP-440-compliant version
    (Closes: #1029775)
  * Drop all CUDA-specific library path search, fixes RUNPATH lintian
    error

 -- Andreas Beckmann <anbe@debian.org>  Tue, 31 Jan 2023 17:13:52 +0100

pyhst2 (2020c-6) unstable; urgency=medium

  * Team upload.

  [ Neil Williams ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Repository.

  [ Andreas Beckmann ]
  * Switch Build-Depends to nvidia-cuda-toolkit-gcc.  (Closes: #1016633)
  * Fix typos found by Lintian.
  * Set Rules-Requires-Root: no.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 22 Nov 2022 15:39:59 +0100

pyhst2 (2020c-5) unstable; urgency=medium

  * Team upload.
  * Binary upload for contrib

 -- Neil Williams <codehelp@debian.org>  Tue, 30 Nov 2021 16:37:15 +0000

pyhst2 (2020c-4) unstable; urgency=medium

  * Team upload.
  * Fix error in B-D to use python3-all-dev to support builds against
    other versions of Python. (Closes: #1000292)

 -- Neil Williams <codehelp@debian.org>  Tue, 30 Nov 2021 12:38:27 +0000

pyhst2 (2020c-3) unstable; urgency=medium

  * Team upload.
  * Upload with amd64 binaries to deal with non-free
  * Improve copyright syntax - lintian warnings
  * Patch shebang line into scripts/vol2hdf5 to fix execution from
    /usr/bin/

 -- Neil Williams <codehelp@debian.org>  Thu, 07 Oct 2021 09:56:26 +0100

pyhst2 (2020c-2) unstable; urgency=medium

  * Team upload.
  * Add missing B-D: python3-six (Closes: #994896)
  * Improve clean rule for generated file
  * Bump Standards Version

 -- Neil Williams <codehelp@debian.org>  Tue, 28 Sep 2021 15:28:16 +0100

pyhst2 (2020c-1) unstable; urgency=medium

  * new Upstream 2020c (Closes: #972914)
  * pathes/0001-support-cuda-11.patch  (Closes: #968318)

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 29 Jan 2021 15:14:00 +0100

pyhst2 (2020a-3) unstable; urgency=medium

  * non-source upload to deal with non-free

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 18 Sep 2020 09:59:19 +0200

pyhst2 (2020a-2) unstable; urgency=medium

  [ Sébastien Delafond ]
  * Update maintainer and salsa location

  [ Picca Frédéric-Emmanuel ]
  * d/control: Added myself has Uploader
  * d/control: Added mpi-default-dev Build-Depends to fix an FTBFS.
  * d/patches: ONLYCUDA=0 in order to have the Python modules and the scripts
  * d/rules: remove the harcoded python3.8
  * d/salsa-ci.yml: Added non-free component

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 26 Jul 2020 08:15:41 +0200

pyhst2 (2020a-1) unstable; urgency=medium

  * First release (Closes: #711554)

 -- Sebastien Delafond <seb@debian.org>  Mon, 23 Mar 2020 13:14:40 +0100

=== debian/control ===
Source: pyhst2
Section: contrib/python
Priority: optional
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
           Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>,
           Sebastien Delafond <seb@debian.org>,
           Picca Frédéric-Emmanuel <picca@debian.org>
Build-Depends: cython3,
               debhelper-compat (= 13),
               dh-python,
               libfftw3-dev,
               libhdf5-dev,
               libtiff-dev,
               mpi-default-dev,
               nvidia-cuda-toolkit-gcc,
               python3:any,
               python3-all,
               python3-all-dev,
               python3-glymur,
               python3-h5py,
               python3-mpi4py,
               python3-numpy,
               python3-setuptools,
               python3-six,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://gitlab.esrf.fr/mirone/pyhst2
Vcs-Browser: https://salsa.debian.org/science-team/pyhst2
Vcs-Git: https://salsa.debian.org/science-team/pyhst2.git

Package: python3-pyhst2-cuda
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
 python3-six, python3-numpy, python3-mpi4py, python3-glymur, python3-h5py
Description: Python High Speed Tomographic reconstruction
 PyHST is a Python program for Tomographic data reconstruction based
 on direct filtered back-projection algorithm
 .
 This is the CUDA version

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=pyhst2
#export PYBUILD_DISABLE=test
#export PYBUILD_VERSIONS=3.8
#export PYBUILD_INTERPRETERS=python{version}

# note: the upstream setup.py does not install a requires.txt into
# the generated egg-info directory, so dh_python3 does not pick up
# the modules used by the installed scripts. Maintain that list in
# debian/control manually.

export CUDAHOME=/usr

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_clean:
	dh_clean
	$(RM) PyHST/segment/segment_cy.cpp

execute_before_dh_gencontrol:
	dh_numpy3 -p python3-pyhst2-cuda
